#!/usr/local/bin/perl

$base_directory = "uploaded-files";
$max_file_size = 100*1024*1024; # 100 MB, -1: unlimited

use CGI qw/:standard/;

$CGI::POST_MAX = $max_file_size;

$query = new CGI;

if ((scalar $query->param) < 1)
{
   print "invalid body"; # will cause premature header error
   exit;
}

$base_directory = $base_directory . '/' . $query->param('directory') . '/';
$base_directory =~ s{//}{/}g;

foreach $ptmp ($query->param)
{
   if ($ptmp !~ /userfile/)
   {
      next;
   }
   @tmps = $query->param($ptmp);
   @infiles = $query->upload($ptmp);
   $i = 0;
   foreach $tmp (@tmps)
   {
      $infile = $tmps[$i++];
      $tmp =~ s/\%([A-Fa-f0-9]{2})/pack('C', hex($1))/seg;
      $tmp =~ s/\+/ /sg;
      $tmp =~ s/\\/\//g;
      $tmp =~ s/^\/(.+)$/$1/g;
      $tmp =~ s/\.\././g;
      $filename = $base_directory . $tmp;
      $dir = $filename;
      $dir =~ s/^(.+\/)[^\/]+$/$1/;
      @dirs = split('/', $dir);
      $cur = '';
      foreach $d (@dirs)
      {
         $cur = $cur . $d . '/';
         if ($cur !~ /\/[^\/]+/)
         {
            next;
         }
         mkdir $cur;
         if ($! ne '' && $! ne 'File exists')
         {
            print "could not make dir $cur"; # premature header error
            exit;
         }
      }
      open $outfile, ">$filename";
      binmode $outfile;
      binmode $infile;
      while (<$infile>)
      {
         print $outfile $_;
      }
      close $outfile;
      close $infile;
   }
}

print "Content-Type: text/html\r\n\r\n";
exit; 
